Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# PanamaHash< B > Class Template Reference

`#include <panama.h>`

Inheritance diagram for PanamaHash< B >:

List of all members.

## Detailed Description

### template<class B = LittleEndian>
class PanamaHash< B >

Panama Hash

Definition at line 29 of file panama.h.

## Public Types
enum | { DIGESTSIZE = 32 }
typedef NativeByteOrder | ByteOrderClass
typedef word32 | HashWordType
## Public Member Functions
| PanamaHash ()
unsigned int | DigestSize () const
| size of the hash returned by Final()
void | TruncatedFinal (byte *hash, unsigned int size)
| truncated version of Final()
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
ByteOrder | GetByteOrder () const
| IteratedHashBase ()
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
void | Update (const byte *input, unsigned int length)
| process more input
byte * | CreateUpdateSpace (unsigned int &size)
| request space to write input into
void | Restart ()
| discard the current state, and restart with a new message
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, unsigned int digestSize, const byte *input, unsigned int length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, unsigned int digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, unsigned int digestLength, const byte *input, unsigned int length)
| truncated version of VerifyDigest()
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Static Public Member Functions
static const char * | StaticAlgorithmName ()
static void | CorrectEndianess (HashWordType *out, const HashWordType *in, unsigned int byteCount)
## Static Public Attributes
static CompileAssert<((BLOCKSIZE &(BLOCKSIZE-1))==0) | cryptopp_assert___LINE__ )
## Protected Types
typedef word32 | Stage [8]
enum | { STAGES = 32 }
## Protected Member Functions
void | Init ()
void | HashEndianCorrectedBlock (const word32 *data)
unsigned int | HashMultipleBlocks (const word32 *input, unsigned int length)
void | Reset ()
void | Iterate (unsigned int count, const word32 *p=NULL, word32 *z=NULL, const word32 *y=NULL)
| IteratedHash ()
void | SetBlockSize (unsigned int blockSize)
void | SetStateSize (unsigned int stateSize)
word32 | GetBitCountHi () const
word32 | GetBitCountLo () const
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
virtual void | HashEndianCorrectedBlock (const HashWordType *data)=0
void | HashBlock (const HashWordType *input)
void | ThrowIfInvalidTruncatedSize (unsigned int size) const
## Protected Attributes
FixedSizeSecBlock< word32, 17 *2+STAGES *sizeof(Stage) | m_state )
unsigned int | m_bstart
SecBlock< word32 > | m_data
SecBlock< word32 > | m_digest

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

| compute hash for current message, then restart for a new message Precondition: size of digest == DigestSize(). Definition at line 532 of file cryptlib.h. Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), PKCS5_PBKDF2_HMAC< T >::DeriveKey(), DefaultEncryptor::FirstPut(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

| verify that digest is a valid digest for the current message, then reinitialize the object Default implementation is to call Final() and do a bitwise comparison between its output and digest. Definition at line 558 of file cryptlib.h. Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

The documentation for this class was generated from the following files:

- panama.h
- panama.cpp